import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:apptics_flutter/apptics_flutter_method_channel.dart';

void main() {
  MethodChannelAppticsFlutter platform = MethodChannelAppticsFlutter();
  const MethodChannel channel = MethodChannel('apptics_flutter');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await platform.getPlatformVersion(), '42');
  });
}
