import 'package:flutter_test/flutter_test.dart';
import 'package:apptics_flutter/apptics_flutter.dart';
import 'package:apptics_flutter/apptics_flutter_platform_interface.dart';
import 'package:apptics_flutter/apptics_flutter_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockAppticsFlutterPlatform
    with MockPlatformInterfaceMixin
    implements AppticsFlutterPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final AppticsFlutterPlatform initialPlatform = AppticsFlutterPlatform.instance;

  test('$MethodChannelAppticsFlutter is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelAppticsFlutter>());
  });

  test('getPlatformVersion', () async {
    AppticsFlutter appticsFlutterPlugin = AppticsFlutter();
    MockAppticsFlutterPlatform fakePlatform = MockAppticsFlutterPlatform();
    AppticsFlutterPlatform.instance = fakePlatform;

    expect(await appticsFlutterPlugin.getPlatformVersion(), '42');
  });
}
